<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:template match="/">
    <html>
      <HEAD>
        <TITLE>852 Licence Generator Report</TITLE>
        <link href="gsreport.css" rel="stylesheet" type="text/css"/>
        <style>
          TABLE
          {
          color: #222222;
          font-size: 10pt;
          font-family: 'Microsoft Sans Serif';
          }
          th
          {
          color: white;
          background-color: darkgray;
          font-size: 10pt;
          padding-right: 5px;
          padding-left: 5px;
          padding-bottom: 5px;
          padding-top: 5px;
          }

          td
          {
          text-align: center;
          padding-right: 5px;
          padding-left: 5px;
          padding-bottom: 0px;
          padding-top: 0px;
          }

          H1					{ color:#111111; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:3px; border-bottom-color:#444488; }
          H2					{ color:#222222; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:2px; border-bottom-color:#444488; }
          H3					{ color:#333333; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#444488; margin-bottom:8px; }
          H4					{ color:#444444; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#CCCCDD; margin-bottom:8px; }
          H5					{ color:#555555; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#EEEEFF; margin-bottom:8px; }
          H6					{ color:#666666; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#F8F8FF; margin-bottom:8px; }

          SPAN.good			{ color:#006666; font-weight:bold; }
          SPAN.critical		{ color:#880000; font-weight:bold; }
          }
        </style>
        <!--       <STYLE>
          TABLE				{ color:#222222; font-size:10pt; font-family:'‚l‚r SVbN' 'sanserif'; }
          TH					{ font-weight:normal; color:#FFFFFF; background-color:#888888; }
          TR.check			{ background-color:#EEEEEE }
          TD.check			{ background-color:#EEEEEE }
          H1					{ color:#111111; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:3px; border-bottom-color:#444488; }
          H2					{ color:#222222; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:2px; border-bottom-color:#444488; }
          H3					{ color:#333333; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#444488; margin-bottom:8px; }
          H4					{ color:#444444; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#CCCCDD; margin-bottom:8px; }
          H5					{ color:#555555; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#EEEEFF; margin-bottom:8px; }
          H6					{ color:#666666; font-family:'Times New Roman' '‚l‚r ‚o–ľ’©' 'serif'; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#F8F8FF; margin-bottom:8px; }

          SPAN.good			{ color:#006666; font-weight:bold; }
          SPAN.critical		{ color:#880000; font-weight:bold; }
        </STYLE> -->
      </HEAD>
      <body>
        <H1>852 Licence Generator Report</H1>
        <!--
        This is an XSLT template file. Fill in this area with the
        XSL elements which will transform your XML to XHTML.
    -->
        <xsl:apply-templates/>
      </body>
    </html>
  </xsl:template>


  <xsl:template match="OpcGroups">
    <H4>OPC Groups</H4>
    <xsl:choose>
      <xsl:when test="OpcGroup">
        <TABLE>
          <TR>
            <TH>Name</TH>
            <TH>Update Rate</TH>
            <TH>Last Update Rate</TH>
            <TH>Locale Id</TH>
            <TH>Server Handle</TH>
            <TH>Client Handle</TH>
            <TH>Deadband</TH>
            <TH>Timebias</TH>
            <TH>Active</TH>
            <TH>Public</TH>
            <TH>Subscribed</TH>
            <TH>Items count</TH>
          </TR>
          <xsl:apply-templates select="OpcGroup" mode="A"/>
        </TABLE>
        <xsl:apply-templates mode="B" select="OpcGroup"/>
      </xsl:when>
      <xsl:otherwise>
        <SPAN class="good">No OPC Groups.</SPAN>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="OpcGroup" mode="A">
    <TR>
      <TD valign='top' align='left'>
        <xsl:value-of select="Name"/>
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="UpdateRate"/> ms
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="LastUpdateRate"/> ms
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="LocaleId"/>
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="ServerHandle"/>
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="ClientHandle"/>
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="Deadband"/> %
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="Timebias"/> min.
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="Active"/>
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="Public"/>
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="Subscribed"/>
      </TD>
      <TD valign='top'>
        
      </TD>
    </TR>
  </xsl:template>

  <xsl:template match='OpcGroup' mode='B'>
    <H3>
      OPC Group: <xsl:value-of select="Name"/>
    </H3>
    <xsl:apply-templates select="OpcItems"/>
  </xsl:template>

  <xsl:template match="setting">
    <H2>Configuration</H2>
    <TABLE>
      <xsl:apply-templates select="property"/>
    </TABLE>
  </xsl:template>

  <xsl:template match="property">
    <TR>
      <TD valign='top' style="text-align: left;">
        <b>
          <xsl:value-of select="name"/>:
        </b>
      </TD>
      <TD valign='top' style="text-align: left;">
        <xsl:value-of select="value"/>
      </TD>
    </TR>
  </xsl:template>

  <xsl:template match="lg_data">
    <H2>Data</H2>
    <xsl:choose>
      <xsl:when test="lg_licence">
        <TABLE>
          <TR>
            <TH>Neuron ID</TH>
            <TH>MAC address ID</TH>
            <TH>Key</TH>
          </TR>
          <xsl:apply-templates select="lg_licence"/>
        </TABLE>
      </xsl:when>
      <xsl:otherwise>
        <SPAN class="good">No data available.</SPAN>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="lg_licence">
    <TR>
      <TD valign='top' style="text-align: left;">
        <xsl:value-of select="NID"/>
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="MAC"/>
      </TD>
      <TD valign='top'>
        <xsl:apply-templates select="Key"/>
      </TD>
    </TR>
  </xsl:template>
</xsl:stylesheet>
