// 852LicGenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "852LicGen.h"
#include "852LicGenDlg.h"
#include "licencedlg.h"
#include "GSxmlwriter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define REG_SECTION		_T("Settings")

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMy852LicGenDlg dialog




CMy852LicGenDlg::CMy852LicGenDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CMy852LicGenDlg::IDD, pParent)
	, m_totalCount(0)
	, m_leftCount(0)
	, m_dongleDesc(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy852LicGenDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_TOTAL, m_totalCount);
	DDV_MinMaxByte(pDX, m_totalCount, 0, 240);
	DDX_Text(pDX, IDC_LEFT, m_leftCount);
	DDX_Control(pDX, IDC_LIST1, m_listCtrl);
	DDX_Text(pDX, IDC_DONGLE_DESC, m_dongleDesc);
}

BEGIN_MESSAGE_MAP(CMy852LicGenDlg, CResizableDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_GENERATE, &CMy852LicGenDlg::OnBnClickedGenerate)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_XML_EXPORT, &CMy852LicGenDlg::OnBnClickedXmlExport)
END_MESSAGE_MAP()


// CMy852LicGenDlg message handlers

BOOL CMy852LicGenDlg::OnInitDialog()
{
	CResizableDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	AddAnchor(IDC_GENERATE, TOP_RIGHT);
	AddAnchor(IDOK, BOTTOM_RIGHT);
	AddAnchor(IDC_LIST1, TOP_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_DONGLE_DESC, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_XML_EXPORT, BOTTOM_LEFT);
	

	LoadWindowRect(REG_SECTION, FALSE);

	m_listCtrl.InsertColumn(0, _T("Neuron ID"), LVCFMT_LEFT, 120);
	m_listCtrl.InsertColumn(1,	_T("MAC address"), LVCFMT_LEFT, 120);
	m_listCtrl.InsertColumn(2, _T("Key"), LVCFMT_LEFT, 120);

	CWaitCursor wait;
	m_dongleDesc = m_dongle.GetDongleDescription();
	UpdateData(FALSE);
	RedrawWindow();

	PARTITION part = m_dongle.FindGesyAppPartition(GESY_852LIC_GEN_HEADER);
	if (GET_IS_VALID_PARTITION(part))
	{
		m_dataLG = C852LG(&m_dongle, part);
	}

	FillData();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy852LicGenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		//CAboutDlg dlgAbout;
		CGSAboutDlg dlgAbout;
		dlgAbout.SetProgramName(AFX_IDS_APP_TITLE);
		dlgAbout.DoModal();
	}
	else
	{
		CResizableDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMy852LicGenDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CResizableDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy852LicGenDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMy852LicGenDlg::OnBnClickedGenerate()
{
	CLicenceDlg dlg;

	int idx = m_dataLG.GetFirstUnusedPositionIndex();
	dlg.m_nidString = m_dataLG.GetNeuronID(idx).ToString();

	if (dlg.DoModal() == IDOK)
	{
		if (IDYES == AfxMessageBox(IDS_WANT_GENERATE_KEY, MB_YESNO | MB_ICONQUESTION))
		{
			m_dataLG.SetMacAddress(idx, CMACAddr(dlg.m_macString));
			FillData();
		}
	}
}

void CMy852LicGenDlg::OnDestroy()
{
	SaveWindowRect(REG_SECTION, FALSE);

	CResizableDialog::OnDestroy();
}

void CMy852LicGenDlg::FillData(void)
{
	CWaitCursor wait;

	//m_dataLGOpen(0);
	m_dongleDesc = m_dongle.GetDongleDescription();
	m_totalCount = m_dataLG.GetTotalCount();
	m_leftCount = m_dataLG.GetLeftCount();
	UpdateData(FALSE);
	RedrawWindow();

	CMACAddrList MACs;
	m_dataLG.GetMacAddresses(MACs, 0, m_totalCount);

	m_listCtrl.DeleteAllItems();
	for (BYTE i = 0; i < m_totalCount; i++)
	{
		int idx = m_listCtrl.InsertItem(i, m_dataLG.GetNeuronID(i).ToString());
		CMACAddr mac = (i < MACs.size()) ? MACs[i] : CMACAddr();
		if (!mac.IsEmpty())
		{
			m_listCtrl.SetItemText(idx, 1, mac.ToString(_T('-')));
			m_listCtrl.SetItemText(idx, 2, m_dataLG.GetKey(i));
		}
	}

	EnableControls();

	UpdateData(FALSE);
}

void CMy852LicGenDlg::EnableControls(void)
{
	ENABLE_DIALOG_ITEM(IDC_GENERATE, m_dataLG.GetLeftCount() > 0);
}

void CMy852LicGenDlg::OnBnClickedXmlExport()
{
	CFileDialog filedlg(FALSE, _T("xml"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		_T("XML files (*.xml)|*.xml|"));

	if (filedlg.DoModal() == IDOK) 
	{
		XmlExport(filedlg.GetPathName());
	}
}

void WriteSettingProperty(CGSXmlWriter& wr, LPCTSTR lpName, LPCTSTR lpValue)
{
	wr.WriteStartElement(_T("property"));
	wr.WriteElementValue(_T("name"),		lpName);
	wr.WriteElementValue(_T("value"),	lpValue);
	wr.WriteFullEndElement();
}

void CMy852LicGenDlg::XmlExport(LPCTSTR lpPath)
{
	CGSXmlWriter writer;
	CString text;

	//---------------------------------------------------------
	// Initialize
	writer.Initialize(lpPath);
	writer.WriteProcessingInstruction(_T("xml-stylesheet"), _T("href=\"852LGReport.xslt\" type=\"text/xsl\""));

	writer.WriteStartElement(_T("C852LG_report"));

	//---------------------------------------------------------
	// OPC Server setting
	writer.WriteStartElement(_T("setting"));

	CGSModuleVersion ver;
	WriteSettingProperty(writer, _T("Product name"), ver.GetProductName());
	WriteSettingProperty(writer, _T("Product version"), ver.GetProductVersion());
	WriteSettingProperty(writer, _T("Copyright"), ver.GetLegalCopyright());

	CWaitCursor wait;
	WriteSettingProperty(writer, _T("Dongle description"), m_dongle.GetDongleDescription());
	WriteSettingProperty(writer, _T("Total count of licences"), itoa(m_dataLG.GetTotalCount()));
	WriteSettingProperty(writer, _T("Left licences"), itoa(m_dataLG.GetLeftCount()));

	writer.WriteFullEndElement();	// setting

	CMACAddrList MACs;
	m_dataLG.GetMacAddresses(MACs, 0, m_totalCount);

	writer.WriteStartElement(_T("lg_data"));

	for (BYTE i = 0; i < m_totalCount; i++)
	{
		writer.WriteStartElement(_T("lg_licence"));

		writer.WriteElementValue(_T("NID"),		m_dataLG.GetNeuronID(i).ToString());

		CMACAddr mac = (i < MACs.size()) ? MACs[i] : CMACAddr();
		if (!mac.IsEmpty())
		{
			writer.WriteElementValue(_T("MAC"),	mac.ToString(_T('-')));
			writer.WriteElementValue(_T("Key"),	m_dataLG.GetKey(i));
		}
		else
		{
			writer.WriteElementValue(_T("MAC"), _T("- free -"));
			writer.WriteElementValue(_T("Key"),	_T("- free -"));
		}
		writer.WriteFullEndElement();	// lg_licence
	}
	writer.WriteFullEndElement();		// lg_data


	writer.WriteFullEndElement();	// 852LG_report

	//---------------------------------------------------------
	// finish the xml file
	writer.Close();
}
