#include "StdAfx.h"
#include "Data852LG.h"
#include "GesyApplicationsEnum.h"

CData852LG::CData852LG(void)
: m_totalCount(5), m_baseNID(_T("80001122330"))
{
}

CData852LG::~CData852LG(void)
{
}

BYTE CData852LG::GetTotalCount(void)
{
	return m_totalCount;
}

BYTE CData852LG::GetLeftCount(void)
{
	int idx = GetFirstUnusedIndex();
	if (idx >= 0 && (idx <= GetTotalCount()))
		return GetTotalCount() - idx;
	else
		return 0;
}

void CData852LG::SetBaseNeuronID(CGSNeuronID& nid)
{
	m_baseNID = nid;
}

CGSNeuronID CData852LG::GetNeuronID(int index)
{
	ASSERT(index < GetTotalCount());

	if (!m_baseNID.IsEmpty())
	{
		BYTE nid[NEURON_ID_LEN];
		m_baseNID.GetData(nid);

		//change last byte only
		nid[NEURON_ID_LEN-1] += index;

		return CGSNeuronID(nid);
	}

	return m_baseNID;
}

CMACAddr CData852LG::GetMacAddress(int index)
{
	ASSERT(index < GetTotalCount());

	CMACAddr mac;
	return mac;
}

void CData852LG::SetMacAddress(int index, CMACAddr macAddr)
{
	ASSERT(index < GetTotalCount());


}

CString CData852LG::GetKey(int index)
{
	return _T("key");
}


CString CData852LG::GenerateKey(CGSNeuronID nid, CMACAddr macAddr)
{
	ASSERT(!nid.IsEmpty());
	ASSERT(!macAddr.IsEmpty());

	if ((nid.IsEmpty()) || (macAddr.IsEmpty()))
		return _T("");

	return CString();
}

int CData852LG::GetFirstUnusedIndex(void)
{
	for (int i = 0; i < GetTotalCount(); i++)
	{
		if (this->GetMacAddress(i).IsEmpty())
			return i;
	}

	return -1;
}

CGSNeuronID CData852LG::GetNextUnusedNeuronID(void)
{
	int idx = GetFirstUnusedIndex();
	if (idx >= 0)
		return GetNeuronID(idx);

	return CGSNeuronID();
}

void CData852LG::Init(void)
{
/*	WORD wPart = FindGesyAppPartition(GESY_852LIC_GEN_HEADER);
	if (wPart != INVALID_APPLICATION)
	{
		this->OpenByIndex()ReadMemoryDataObject();
	}*/
}
